Index: pkpgcounter/trunk/pkpgpdls/mscrap.py
===================================================================
--- pkpgcounter/trunk/pkpgpdls/mscrap.py (revision 523)
+++ pkpgcounter/trunk/pkpgpdls/mscrap.py (revision 523)
@@ -0,0 +1,54 @@
+#! /usr/bin/env python
+# -*- coding: ISO-8859-15 -*-
+#
+# pkpgcounter : a generic Page Description Language parser
+#
+# (c) 2003, 2004, 2005, 2006, 2007 Jerome Alet <alet@librelogiciel.com>
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+# 
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+# 
+# You should have received a copy of the GNU General Public License
+# along with this program.  If not, see <http://www.gnu.org/licenses/>.
+#
+# $Id$
+#
+
+"""This module implements a page counter for Microsoft Word (r) (tm) (c) (etc...) documents"""
+
+import os
+import urllib2
+
+import pdlparser
+import version
+
+class Parser(pdlparser.PDLParser) :
+    """A parser for that MS crap thing."""
+    totiffcommands = [ ]
+    def isValid(self) :    
+        """Returns True if data is MS crap, else False.
+        
+           Identifying datas taken from the file command's magic database.
+           IMPORTANT : some magic values are not reused here because they
+           IMPORTANT : seem to be specific to some particular i18n release.
+        """   
+        if self.firstblock.startswith("PO^Q`") \
+           or self.firstblock.startswith("\xd0\xcf\x11\xe0\xa1\xb1\x1a\xe1") \
+           or self.firstblock.startswith("\xfe7\x00#") \
+           or self.firstblock.startswith("\xdb\xa5-\x00\x00\x00") \
+           or self.firstblock.startswith("\x31\xbe\x00\x00") \
+           or self.firstblock[2112:].startswith("MSWordDoc") :
+            self.logdebug("DEBUG: Input file seems to be in a Microsoft shitty file format.")
+            return True
+        else :    
+            return False
+            
+    def getJobSize(self) :
+        """Counts pages in a Microsoft Word (r) (tm) (c) (etc...) document."""
+        return 0
Index: pkpgcounter/trunk/pkpgpdls/analyzer.py
===================================================================
--- pkpgcounter/trunk/pkpgpdls/analyzer.py (revision 522)
+++ pkpgcounter/trunk/pkpgpdls/analyzer.py (revision 523)
@@ -28,5 +28,5 @@
 import tempfile
 
-import version, pdlparser, postscript, pdf, pcl345, pclxl, hbp, pil, mstrash, \
+import version, pdlparser, postscript, pdf, pcl345, pclxl, hbp, pil, mscrap, \
        lidil, escp2, dvi, tiff, ooo, zjstream, qpdl, spl1, escpages03, plain
 import inkcoverage
@@ -163,5 +163,5 @@
                        escpages03, \
                        pil, \
-                       mstrash, \
+                       mscrap, \
                        plain) :     # IMPORTANT : don't move this one up !
             try :               
Index: pkpgcounter/trunk/pkpgpdls/mstrash.py
===================================================================
--- pkpgcounter/trunk/pkpgpdls/mstrash.py (revision 522)
+++  (revision )
@@ -1,54 +1,0 @@
-#! /usr/bin/env python
-# -*- coding: ISO-8859-15 -*-
-#
-# pkpgcounter : a generic Page Description Language parser
-#
-# (c) 2003, 2004, 2005, 2006, 2007 Jerome Alet <alet@librelogiciel.com>
-# This program is free software: you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation, either version 3 of the License, or
-# (at your option) any later version.
-# 
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-# 
-# You should have received a copy of the GNU General Public License
-# along with this program.  If not, see <http://www.gnu.org/licenses/>.
-#
-# $Id$
-#
-
-"""This module implements a page counter for Microsoft Word (r) (tm) (c) (etc...) documents"""
-
-import os
-import urllib2
-
-import pdlparser
-import version
-
-class Parser(pdlparser.PDLParser) :
-    """A parser for that MS crap thing."""
-    totiffcommands = [ ]
-    def isValid(self) :    
-        """Returns True if data is MS crap, else False.
-        
-           Identifying datas taken from the file command's magic database.
-           IMPORTANT : some magic values are not reused here because they
-           IMPORTANT : seem to be specific to some particular i18n release.
-        """   
-        if self.firstblock.startswith("PO^Q`") \
-           or self.firstblock.startswith("\xd0\xcf\x11\xe0\xa1\xb1\x1a\xe1") \
-           or self.firstblock.startswith("\xfe7\x00#") \
-           or self.firstblock.startswith("\xdb\xa5-\x00\x00\x00") \
-           or self.firstblock.startswith("\x31\xbe\x00\x00") \
-           or self.firstblock[2112:].startswith("MSWordDoc") :
-            self.logdebug("DEBUG: Input file seems to be in a Microsoft shitty file format.")
-            return True
-        else :    
-            return False
-            
-    def getJobSize(self) :
-        """Counts pages in a Microsoft Word (r) (tm) (c) (etc...) document."""
-        return 0