Index: pkpgcounter/trunk/bin/pkpgcounter
===================================================================
--- pkpgcounter/trunk/bin/pkpgcounter (revision 502)
+++ pkpgcounter/trunk/bin/pkpgcounter (revision 528)
@@ -40,13 +40,13 @@
 
     * PostScript (both DSC compliant and binary)
-    * PDF   
+    * PDF
     * PCLXL (aka PCL6)
-    * PCL3/4/5 (mostly)
+    * PCL3/4/5
     * DVI
+    * OpenDocument (ISO/IEC DIS 26300)
     * Plain text
     * TIFF
     * Several other image formats
     * ESC/P2
-    * OpenDocument (ISO/IEC DIS 26300)
     * Zenographics ZjStream
     * Samsung QPDL (aka SPL2)
@@ -56,6 +56,6 @@
     * Hewlett-Packard LIDIL (hpijs)
 
-The eight latter ones, as well as some TIFF documents, are currently 
-only supported in page counting mode. 
+The seven latter ones, as well as some TIFF documents, are currently
+only supported in page counting mode.
 
 command line usage :
Index: pkpgcounter/trunk/man/pkpgcounter.1
===================================================================
--- pkpgcounter/trunk/man/pkpgcounter.1 (revision 502)
+++ pkpgcounter/trunk/man/pkpgcounter.1 (revision 528)
@@ -2,7 +2,7 @@
 .TH PKPGCOUNTER "1" "November 2007" "C@LL - Conseil Internet & Logiciels Libres" "User Commands"
 .SH NAME
-pkpgcounter \- manual page for pkpgcounter 3.30
+pkpgcounter \- manual page for pkpgcounter 3.40alpha
 .SH DESCRIPTION
-pkpgcounter v3.30 (c) 2003, 2004, 2005, 2006, 2007 Jerome Alet
+pkpgcounter v3.40alpha (c) 2003, 2004, 2005, 2006, 2007 Jerome Alet
 .PP
 pkpgcounter is a generic Page Description Language parser.
@@ -19,11 +19,11 @@
 * PDF
 * PCLXL (aka PCL6)
-* PCL3/4/5 (mostly)
+* PCL3/4/5
 * DVI
+* OpenDocument (ISO/IEC DIS 26300)
 * Plain text
 * TIFF
 * Several other image formats
 * ESC/P2
-* OpenDocument (ISO/IEC DIS 26300)
 * Zenographics ZjStream
 * Samsung QPDL (aka SPL2)
@@ -33,5 +33,5 @@
 * Hewlett\-Packard LIDIL (hpijs)
 .PP
-The eight latter ones, as well as some TIFF documents, are currently
+The seven latter ones, as well as some TIFF documents, are currently
 only supported in page counting mode.
 .PP
Index: pkpgcounter/trunk/README
===================================================================
--- pkpgcounter/trunk/README (revision 527)
+++ pkpgcounter/trunk/README (revision 528)
@@ -35,4 +35,6 @@
         - DVI
         
+        - OpenDocument (ISO/IEC DIS 26300)
+        
         - Plain text
         
@@ -42,6 +44,4 @@
         
         - ESC/P2
-        
-        - OpenDocument (ISO/IEC DIS 26300)
         
         - Zenographics ZjStream
@@ -57,5 +57,5 @@
         - Hewlett-Packard Lightweight Imaging Device Interface Language
         
-The eight latter ones, as well as some TIFF documents, are currently 
+The seven latter ones, as well as some TIFF documents, are currently 
 only supported in page counting mode. 
 
@@ -109,15 +109,17 @@
 DEPENDENCIES :
 
-  Depending on the file formats you plan to work with, and on the accounting
-  mode you want to use (pages vs ink), you may need to install some or all
-  of the additional software listed below. Usually, if one is needed then
-  pkpgcounter will complain. So your best bet is probably to not install
-  anything until pkpgcounter asks you to do so on its standard error
-  stream. Here's the list of software which may be needed for some
-  operations with pkpgcounter :
+  Most of the time, pkpgcounter only depends on the presence of :
+  
+  - The Python Imaging Library (python-imaging)
+  
+  But, depending on the file formats you plan to work with, and on the
+  accounting mode you want to use (pages vs ink), you may need to install
+  some or all of the additional software listed below. Usually, if one is
+  needed then pkpgcounter will complain. So your best bet is probably 
+  to NOT INSTALL anything until pkpgcounter asks you to do so on its
+  standard error stream. Here's the list of software which may be needed
+  for some operations with pkpgcounter :
 
   - GhostScript (gs)
-  
-  - The Python Imaging Library (python-imaging)
   
   - The X Virtual Frame Buffer (xvfb)
@@ -140,5 +142,6 @@
   If pkpgcounter gives incorrect results to you, please make an incorrectly
   parsed data file available to us on some website, and tell us which 
-  driver was used.
+  driver was used, how many pages are in the file, and any additional 
+  information you think is relevant.
   
   If pkpgcounter complain about your system lacking the Python Psyco module,